
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class App_crash_reportsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_crash_reports = await db.app_crash_reports.create(
            {
                id: data.id || undefined,
        
        severity: data.severity
        ||
        null
            ,
            
        client_platform: data.client_platform
        ||
        null
            ,
            
        client_version: data.client_version
        ||
        null
            ,
            
        reported_at: data.reported_at
        ||
        null
            ,
            
        stacktrace: data.stacktrace
        ||
        null
            ,
            
        context_payload: data.context_payload
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await app_crash_reports.setMarketplace_app( data.marketplace_app || null, {
            transaction,
        });
        
        await app_crash_reports.setUser( data.user || null, {
            transaction,
        });
        
        await app_crash_reports.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return app_crash_reports;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const app_crash_reportsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                severity: item.severity
            ||
            null
            ,
            
                client_platform: item.client_platform
            ||
            null
            ,
            
                client_version: item.client_version
            ||
            null
            ,
            
                reported_at: item.reported_at
            ||
            null
            ,
            
                stacktrace: item.stacktrace
            ||
            null
            ,
            
                context_payload: item.context_payload
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const app_crash_reports = await db.app_crash_reports.bulkCreate(app_crash_reportsData, { transaction });

        // For each item created, replace relation files
        

        return app_crash_reports;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const app_crash_reports = await db.app_crash_reports.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.client_platform !== undefined) updatePayload.client_platform = data.client_platform;
        
        
        if (data.client_version !== undefined) updatePayload.client_version = data.client_version;
        
        
        if (data.reported_at !== undefined) updatePayload.reported_at = data.reported_at;
        
        
        if (data.stacktrace !== undefined) updatePayload.stacktrace = data.stacktrace;
        
        
        if (data.context_payload !== undefined) updatePayload.context_payload = data.context_payload;
        
        
        updatePayload.updatedById = currentUser.id;

        await app_crash_reports.update(updatePayload, {transaction});

        
        
        if (data.marketplace_app !== undefined) {
            await app_crash_reports.setMarketplace_app(
              
              data.marketplace_app,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await app_crash_reports.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await app_crash_reports.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return app_crash_reports;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_crash_reports = await db.app_crash_reports.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of app_crash_reports) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of app_crash_reports) {
                await record.destroy({transaction});
            }
        });


        return app_crash_reports;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const app_crash_reports = await db.app_crash_reports.findByPk(id, options);

        await app_crash_reports.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await app_crash_reports.destroy({
            transaction
        });

        return app_crash_reports;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const app_crash_reports = await db.app_crash_reports.findOne(
            { where },
            { transaction },
        );

        if (!app_crash_reports) {
            return app_crash_reports;
        }

        const output = app_crash_reports.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.marketplace_app = await app_crash_reports.getMarketplace_app({
            transaction
        });
        
        
        output.user = await app_crash_reports.getUser({
            transaction
        });
        
        
        output.organizations = await app_crash_reports.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.marketplace_apps,
        as: 'marketplace_app',
        
        where: filter.marketplace_app ? {
          [Op.or]: [
            { id: { [Op.in]: filter.marketplace_app.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.marketplace_app.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.client_platform) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_crash_reports',
                        'client_platform',
                        filter.client_platform,
                    ),
                };
            }
            
            if (filter.client_version) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_crash_reports',
                        'client_version',
                        filter.client_version,
                    ),
                };
            }
            
            if (filter.stacktrace) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_crash_reports',
                        'stacktrace',
                        filter.stacktrace,
                    ),
                };
            }
            
            if (filter.context_payload) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_crash_reports',
                        'context_payload',
                        filter.context_payload,
                    ),
                };
            }
            

            
            

            
            if (filter.reported_atRange) {
                const [start, end] = filter.reported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.app_crash_reports.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'app_crash_reports',
                        'client_platform',
                        query,
                    ),
                ],
            };
        }

        const records = await db.app_crash_reports.findAll({
            attributes: [ 'id', 'client_platform' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['client_platform', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.client_platform,
        }));
    }

    
};

